<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>fetch.html</title>
    <script src="table.js"></script>
</head>

<body>
    <script>
        //동기방식
        console.log('1');
        console.log('2');
        console.log('3');

        //Ajax호출
        //비동기방식
        // setTimeout(function () {
        //     console.log('1');
        // }, 2000)
        // setTimeout(function () {
        //     console.log('2');
        // }, 1500)
        // setTimeout(function () {
        //     console.log('3');
        // }, 1000)

        //순차적으로 처리하고 싶을때 => 복잡하다. => fetch사용
        // setTimeout(function () { 
        //     console.log('1');
        //     setTimeout(function () {
        //         console.log('2');
        //         setTimeout(function () {
        //             console.log('3');
        //         }, 1000)
        //     }, 1500)
        // }, 2000)

        



        //프로미스객체 
        let promise = new Promise(function (resolve, reject) {
            let isOk = true;
            if (isOk) {
                //에러없이 정상적으로 실행되면 실행될 resolve
                resolve(); //=>then에서 가져옴
            } else {
                //에러발생시 실행될 reject
                reject(); //=>catch에서 가져옴
            }
        });

        promise
            .then(function (result) { //정상적으로 실행될때
                console.log('성공했을 경우 실행됨');
                return new Promise(function (resolve, reject) {
                    resolve('success');
                    //reject('error')  //catch를 실행시킴
                });
            })
            .then(function (result) { //result에 resolve의 매개값이 넘어옴
                console.log('두번째 성공' + result);
            })
            .catch(function (error) { //에러가 발생할때
                console.log('실패했을 경우 실행됨');
            });

        //fetch구문
        fetch('MOCK_DATA.json') //데이터요청=> 반환결과 :promise 객체반환.
            .then((result) => { //정상적으로 가져왓을때
                //console.log(result); //Stream형태의 데이터 (바로 읽을수 없다)
                //json(); => json포맷의 스트림을 javascript객체로 변환시켜주는 메소드
               return result.json(); 
                //throw new Error('에러발생'); //promise객체처리
            })
            .then((result) => {
                console.log(result); //변환된 데이터
            })
            .then()
            .catch((error) => { //못가져왔을때
                console.log(error);
            });

            //간단히 표현 (실행문이 하나일땐 return과 {}생략가능)
            fetch('MOCK_DATA.json') 
                .then(result => result.json())
                .then(result => {
                    //페이지 생성
                    table.initData = result;
                    document.body.append(table.makeTable());
                })
                .catch(err => console.log(err))

    </script>
</body>

</html>